# -*- encoding: utf-8 -*-

from urllib2 import URLError
from django.contrib import admin
from django.utils.translation import ugettext as _
from models import IndexServer, MonitoredSite


class MonitoredSiteAdmin(admin.ModelAdmin):
    list_display = ('name', 'url', '_pkg_versions', '_pkg_obsoletes', )


    def display_versions_as_html(self, dict_versions):
        html = "<ul>"
        for pkg, versions in dict_versions.items():
            html += "<li><b>%s</b> : %s</li>" % (pkg, versions[0])
        html += "</ul>"
        return html
    
    def _pkg_versions(self, obj):
        try:
            dict_versions = obj.get_packages_versions()
            return self.display_versions_as_html(dict_versions)
        except URLError, e:
            return _('Problem to reach agent')
    _pkg_versions.allow_tags = True

    def _pkg_obsoletes(self, obj):
        try:
            dict_versions = obj.check_packages_versions()
            return self.display_versions_as_html(dict_versions)
        except URLError, e:
            return _('Problem to reach agent')
    _pkg_obsoletes.allow_tags = True

admin.site.register(IndexServer)
admin.site.register(MonitoredSite, MonitoredSiteAdmin)
